local UPDATEPERIOD, elapsed = 0.5, 0

if not(LightSpeed) then
	LightSpeed = {};
end

if(LightSpeed.toggle == nil) then
	LightSpeed.toggle = false;
end

local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("LightSpeed", {
	type = "data source", 
	text = "0%", 
	icon = "Interface\\Icons\\Ability_Rogue_Sprint",
	OnClick = function(clickedframe, button)
		LightSpeed.toggle = not LightSpeed.toggle;
	end,
})

local f = CreateFrame("frame")

f:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end

	elapsed = 0
	if(LightSpeed.toggle) then
		local speed = GetUnitSpeed("player")
		dataobj.text = string.format(" %.2fy/s", speed)
	else
		local speed = (GetUnitSpeed("player") / 7 * 100)
		dataobj.text = string.format(" %.0f%%", speed)
	end
end)

function dataobj:OnTooltipShow()
	self:AddLine("Click to toggle display method")
end

function dataobj:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOP", self, "BOTTOM")
	GameTooltip:ClearLines()
	dataobj.OnTooltipShow(GameTooltip)
	GameTooltip:Show()
end

function dataobj:OnLeave()
	GameTooltip:Hide()
end
